// SCCreate.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include <objbase.h>
#include <objidl.h>
#include <Shobjidl.h>
#include <SHLGUID.H>

	#define DLL_API __declspec(dllexport)


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
 	switch (ul_reason_for_call)
		{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
		}
	return TRUE;
}

BOOL _fastcall isEmpty(  const char * pStr )
{
const char * P;
P= pStr;

if (P==NULL || *P == 0)
  return true;

while (*P != 0)
 {
 if (*P++ != ' ') //32 )
    return false;
 }
return true;
}


DLL_API HRESULT CreateLink(LPCSTR lpszPathObj, LPCSTR lpszPathLink, LPCSTR lpszWDir, LPCSTR lpszDesc) 
{ 
	CoInitialize(NULL);
    HRESULT hres; 
    IShellLink* psl; 
 
	if(!lpszPathObj || !lpszPathLink || !lpszWDir || !lpszDesc)
		return S_FALSE;


	if(isEmpty(lpszPathObj))
		return S_FALSE;
	if(isEmpty(lpszPathLink))
		return S_FALSE;

    // Get a pointer to the IShellLink interface. 
    hres = CoCreateInstance(CLSID_ShellLink, NULL, 
        CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID *) &psl); 
    if (SUCCEEDED(hres))
	{ 
        IPersistFile* ppf; 
 
        // Set the path to the shortcut target and add the 
        // description. 

        if(psl->SetPath(lpszPathObj) != NOERROR)
			return S_FALSE;

		if(!isEmpty(lpszDesc))
		{
			if(psl->SetDescription(lpszDesc) != NOERROR)
				return S_FALSE;
		}

		if(!isEmpty(lpszWDir))
		{
			if(psl->SetWorkingDirectory(lpszWDir) != NOERROR)
				return S_FALSE;
		}


       // Query IShellLink for the IPersistFile interface for saving the 
       // shortcut in persistent storage. 
        hres = psl->QueryInterface(IID_IPersistFile,(LPVOID *) &ppf); 
 
        if (SUCCEEDED(hres)) 
		{ 
            WCHAR wsz[MAX_PATH]; 
 
            // Ensure that the string is Unicode. 
            MultiByteToWideChar(CP_ACP, 0, lpszPathLink, -1, 
                wsz, MAX_PATH); 
 
            // Save the link by calling IPersistFile::Save. 
            hres = ppf->Save(wsz, TRUE); 
            ppf->Release(); 
        } 
        psl->Release(); 
    } 
	
	CoUninitialize();
    return hres; 
} 

